;##################################################################
; FlatBtn
;##################################################################

#include FlatBtn.h

DATA SECTION
	hInstance	HANDLE		?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitFlatButtons
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_COMMAND
		invoke GetStockObject,DEVICE_DEFAULT_FONT
		invoke SendDlgItemMessage,[hwnd],1001,WM_SETFONT,eax,TRUE
		jmp >.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		cmp D[wParam],1001
		jne >
			invoke MessageBox,0,"Button 1 Pressed",0,0
			jmp >.EXIT
		:
		cmp D[wParam],1002
		jne >
			invoke MessageBox,0,"Button 2 Pressed",0,0
			jmp >.EXIT
		:
		cmp D[wParam],1003
		jne >.EXIT
			invoke MessageBox,0,"Button 3 Pressed",0,0
			jmp >.EXIT
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

InitFlatButtons FRAME
	LOCAL cc_wcx			:WNDCLASSEX

	invoke RtlZeroMemory,offset cc_wcx,SIZEOF WNDCLASSEX
	invoke GetModuleHandle,0
	mov D[cc_wcx.hInstance],eax
	mov D[cc_wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[cc_wcx.lpszClassName],OFFSET UDC_Class
	mov D[cc_wcx.cbClsExtra],0
	mov D[cc_wcx.style],0
	mov D[cc_wcx.cbWndExtra],8
	mov D[cc_wcx.lpfnWndProc],OFFSET FlatBtnproc
	mov D[cc_wcx.hbrBackground],COLOR_BTNFACE+1
	invoke RegisterClassEx,ADDR cc_wcx

	ret

	UDC_Class:	db		"FLTBTNCLASS",0
ENDF

FlatBtnproc FRAME hwnd,uMsg,wParam,lParam
	uses ebx
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	LOCAL BtnText[256]:%TCHAR
	LOCAL TE:TRACKMOUSEEVENT

	.WM_CREATE
	cmp D[uMsg],WM_CREATE
	jne >>.WM_SETFONT
		invoke GetStockObject,DEFAULT_GUI_FONT
		invoke SetWindowLong,[hwnd],4,eax
		invoke SetWindowLong,[hwnd],0,FALSE
		jmp >>.DEFPROC

	.WM_SETFONT
	cmp D[uMsg],WM_SETFONT
	jne >>.WM_LBUTTONUP
		invoke SetWindowLong,[hwnd],4,[wParam]
		cmp D[lParam],TRUE
		jne >
		invoke InvalidateRect,[hwnd],NULL,TRUE
		:
		xor eax,eax
		ret

	.WM_LBUTTONUP
	cmp D[uMsg],WM_LBUTTONUP
	jne >>.WM_MOUSEMOVE
		invoke GetDlgCtrlID,[hwnd]
		mov ebx,eax
		invoke GetParent,[hwnd]
		invoke PostMessage,eax,WM_COMMAND,ebx,[hwnd]
		jmp >>.DEFPROC

	.WM_MOUSEMOVE
	cmp D[uMsg],WM_MOUSEMOVE
	jne >>.WM_MOUSELEAVE
		invoke SetWindowLong,[hwnd],0,TRUE
		cmp eax,TRUE
		je >>.DEFPROC
		invoke InvalidateRect,[hwnd],NULL,TRUE
		mov D[TE.cbSize],SIZEOF TRACKMOUSEEVENT
		mov D[TE.dwFlags],TME_LEAVE
		mov eax,[hwnd]
		mov [TE.hwndTrack],eax
		mov D[TE.dwHoverTime],NULL
		invoke TrackMouseEvent,offset TE
		jmp >>.DEFPROC

	.WM_MOUSELEAVE
	cmp D[uMsg],WM_MOUSELEAVE
	jne >>.WM_PAINT
		invoke SetWindowLong,[hwnd],0,FALSE
		invoke InvalidateRect,[hwnd],NULL,TRUE
		jmp >>.DEFPROC

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.DEFPROC
		invoke BeginPaint,[hwnd],offset ps
			invoke GetWindowLong,[hwnd],4
			invoke SelectObject,[ps.hdc],eax
			push eax
			invoke GetClientRect,[hwnd],offset rect
			invoke GetWindowText,[hwnd],offset BtnText,256
			invoke SetTextColor,[ps.hdc],0
			invoke SetBkMode,[ps.hdc],TRANSPARENT
			invoke DrawText,[ps.hdc],addr BtnText,-1,offset rect,DT_CENTER + DT_VCENTER + DT_SINGLELINE
			invoke GetWindowLong,[hwnd],0
			cmp eax,TRUE
			jne >>
				invoke DrawFocusRect,[ps.hdc],offset rect
			:
			pop eax
			invoke SelectObject,[ps.hdc],eax
		invoke EndPaint,[hwnd],offset ps
		xor eax,eax
		inc eax
		ret

	.DEFPROC
	invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
	ret
endf
